/*
 * fsarchiver: Filesystem Archiver
 *
 * Copyright (C) 2008-2009 Francois Dupoux.  All rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License v2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * Homepage: http://www.fsarchiver.org
 */

#ifndef __CRYPTO_H__
#define __CRYPTO_H__

#ifdef OPTION_CRYPTO_SUPPORT

#include <openssl/evp.h>
#include <openssl/rand.h>

#include "types.h"

int crypt_block_blowfish(u64 insize, u64 *outsize, u8 *inbuf, u8 *outbuf, u8 *password, int passlen, int enc);
int generate_random_buffer(u8 *buf, int bufsize);

#endif // OPTION_CRYPTO_SUPPORT

#endif // __CRYPTO_H__
