/*
 * fsarchiver: Filesystem Archiver
 *
 * Copyright (C) 2008-2009 Francois Dupoux.  All rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License v2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * Homepage: http://www.fsarchiver.org
 */

#ifndef __FILESYS_H__
#define __FILESYS_H__

#include <stdio.h>

struct s_dico;

struct s_filesys
{
	char *name;
	int (*mount)(char *partition, char *mntbuf, char *fsname, int flags);
	int (*umount)(char *partition, char *mntbuf);
	int (*get_specific_features)(struct s_dico *d, char *devname);
	int (*mkfs)(struct s_dico *d, char *partition, char *filesystem);
	bool winattr;
};

extern struct s_filesys filesys[];

int get_filesystem_info(char *dev, char *mnt, char *text, int textlen);
int get_filesystem_rw_status(char *options);
int devcmp(char *dev1, char *dev2);
int get_fstype(char *fsname, int *fstype);
int mount_get_devinfo(char *devname, int *readwrite, char *mntbuf, int maxmntbuf, char *optbuf, int maxoptbuf, char *fsbuf, int maxfsbuf);
int mount_generic(char *partition, char *mntbuf, char *fsbuf, char *mntopt, int flags);
int umount_generic(char *mntbuf);

#endif // __FILESYS_H__
