/*
 * fsarchiver: Filesystem Archiver
 *
 * Copyright (C) 2008-2009 Francois Dupoux.  All rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License v2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * Homepage: http://www.fsarchiver.org
 */

#ifndef __FS_NTFS_H__
#define __FS_NTFS_H__

struct s_dico;

struct s_ntfsinfo
{
	u32 bytes_per_sector;
	u32 sectors_per_clusters;
	u64 total_sector_count;
	u64 lcn_of_mft_data_attrib;
	u32 bytes_per_cluster;
	u32 file_record_size;
	s32 clusters_per_mft_record;
};

int ntfs_mkfs(struct s_dico *d, char *partition, char *filesystem);
int ntfs_getinfo(struct s_dico *d, char *devname);
int ntfs_mount(char *partition, char *mntbuf, char *fsbuf, int flags);
int ntfs_umount(char *partition, char *mntbuf);

#endif // __FS_NTFS_H__
