#include <stdio.h>
#include <string.h>
#include <openssl/evp.h>

#define BUFLEN	4096

int main()
{
	FILE *fin, *fout;
	long origsize;
	long finalsize;
	int res;
	int i;
	
        /* Allow enough space in output buffer for additional block */
        char inbuf[BUFLEN], outbuf[BUFLEN + EVP_MAX_BLOCK_LENGTH];
        int inlen, outlen;
	EVP_CIPHER_CTX ctx;
        /* Bogus key and IV: we'd normally set these from
         * another source.
         */
        unsigned char key[] = "0123456789";
        unsigned char iv[] = "12345678";
        /* Don't set key or IV because we will modify the parameters */
	
	// init
	memset(inbuf, 0, sizeof(inbuf));
	memset(outbuf, 0, sizeof(outbuf));
	
        EVP_CIPHER_CTX_init(&ctx);
	int do_encrypt=0; // set 1 for encrypt and 0 for decrypt
	
	// EVP_bf_cbc(void), EVP_bf_ecb(void), EVP_bf_cfb(void), EVP_bf_ofb(void);
        EVP_CipherInit_ex(&ctx, EVP_bf_cfb(), NULL, NULL, NULL, do_encrypt);
        EVP_CIPHER_CTX_set_key_length(&ctx, 10);
	
        /* We finished modifying parameters so now we can set key and IV */
        EVP_CipherInit_ex(&ctx, NULL, NULL, key, iv, do_encrypt);
	
	// ---- 1. COMPRESSION
	fin=fopen("/root/testlzma/file2.txt", "rb");
	if (!fin)
	{	printf ("Cannot open file1.txt\n");
		return 1;
	}
	fout=fopen("/root/testlzma/file3.txt", "wb");
	if (!fout)
	{	printf ("Cannot open file2.txt\n");
		return 1;
	}
	
	for(i=0;;i++)
	{
		inlen = fread(inbuf, 1, BUFLEN, fin);
		if(inlen <= 0) break;
		if(!EVP_CipherUpdate(&ctx, outbuf, &outlen, inbuf, inlen)) // error
		{
			EVP_CIPHER_CTX_cleanup(&ctx);
			return 1;
		}
		fwrite(outbuf, 1, outlen, fout);
		printf("block[%.3d]: in=%ld - out=%ld\n", i, (long)inlen, (long)outlen);
	}
	
	if(!EVP_CipherFinal_ex(&ctx, outbuf, &outlen)) // error
	{
		EVP_CIPHER_CTX_cleanup(&ctx);
		return 1;
	}
	fwrite(outbuf, 1, outlen, fout);
	printf("block[%.3d]: out=%ld\n", i, (long)outlen);
	
	EVP_CIPHER_CTX_cleanup(&ctx);
	
	fclose(fin);
	fclose(fout);

	return 0;
}
